/*******************************************************************************
 * Copyright (C) 2009, Progress Software Corporation and/or its 
 * subsidiaries or affiliates.  All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
#ifdef NATIVE_STATS
extern int CLibrary_nativeFunctionCount;
extern int CLibrary_nativeFunctionCallCount[];
extern char* CLibrary_nativeFunctionNames[];
#define CLibrary_NATIVE_ENTER(env, that, func) CLibrary_nativeFunctionCallCount[func]++;
#define CLibrary_NATIVE_EXIT(env, that, func) 
#else
#ifndef CLibrary_NATIVE_ENTER
#define CLibrary_NATIVE_ENTER(env, that, func) 
#endif
#ifndef CLibrary_NATIVE_EXIT
#define CLibrary_NATIVE_EXIT(env, that, func) 
#endif
#endif

typedef enum {
	CLibrary_init_FUNC,
	CLibrary_isatty_FUNC,
} CLibrary_FUNCS;
#ifdef NATIVE_STATS
extern int Kernel32_nativeFunctionCount;
extern int Kernel32_nativeFunctionCallCount[];
extern char* Kernel32_nativeFunctionNames[];
#define Kernel32_NATIVE_ENTER(env, that, func) Kernel32_nativeFunctionCallCount[func]++;
#define Kernel32_NATIVE_EXIT(env, that, func) 
#else
#ifndef Kernel32_NATIVE_ENTER
#define Kernel32_NATIVE_ENTER(env, that, func) 
#endif
#ifndef Kernel32_NATIVE_EXIT
#define Kernel32_NATIVE_EXIT(env, that, func) 
#endif
#endif

typedef enum {
	Kernel32_CloseHandle_FUNC,
	Kernel32_FillConsoleOutputCharacterW_FUNC,
	Kernel32_FormatMessageW_FUNC,
	Kernel32_GetConsoleMode_FUNC,
	Kernel32_GetConsoleScreenBufferInfo_FUNC,
	Kernel32_GetLastError_FUNC,
	Kernel32_GetStdHandle_FUNC,
	Kernel32_SetConsoleCursorPosition_FUNC,
	Kernel32_SetConsoleMode_FUNC,
	Kernel32_SetConsoleTextAttribute_FUNC,
	Kernel32_SetConsoleTitle_FUNC,
	Kernel32__1getch_FUNC,
	Kernel32_free_FUNC,
	Kernel32_init_FUNC,
	Kernel32_malloc_FUNC,
} Kernel32_FUNCS;
#ifdef NATIVE_STATS
extern int CONSOLE_SCREEN_BUFFER_INFO_nativeFunctionCount;
extern int CONSOLE_SCREEN_BUFFER_INFO_nativeFunctionCallCount[];
extern char* CONSOLE_SCREEN_BUFFER_INFO_nativeFunctionNames[];
#define CONSOLE_SCREEN_BUFFER_INFO_NATIVE_ENTER(env, that, func) CONSOLE_SCREEN_BUFFER_INFO_nativeFunctionCallCount[func]++;
#define CONSOLE_SCREEN_BUFFER_INFO_NATIVE_EXIT(env, that, func) 
#else
#ifndef CONSOLE_SCREEN_BUFFER_INFO_NATIVE_ENTER
#define CONSOLE_SCREEN_BUFFER_INFO_NATIVE_ENTER(env, that, func) 
#endif
#ifndef CONSOLE_SCREEN_BUFFER_INFO_NATIVE_EXIT
#define CONSOLE_SCREEN_BUFFER_INFO_NATIVE_EXIT(env, that, func) 
#endif
#endif

typedef enum {
	CONSOLE_SCREEN_BUFFER_INFO_init_FUNC,
} CONSOLE_SCREEN_BUFFER_INFO_FUNCS;
#ifdef NATIVE_STATS
extern int COORD_nativeFunctionCount;
extern int COORD_nativeFunctionCallCount[];
extern char* COORD_nativeFunctionNames[];
#define COORD_NATIVE_ENTER(env, that, func) COORD_nativeFunctionCallCount[func]++;
#define COORD_NATIVE_EXIT(env, that, func) 
#else
#ifndef COORD_NATIVE_ENTER
#define COORD_NATIVE_ENTER(env, that, func) 
#endif
#ifndef COORD_NATIVE_EXIT
#define COORD_NATIVE_EXIT(env, that, func) 
#endif
#endif

typedef enum {
	COORD_init_FUNC,
} COORD_FUNCS;
#ifdef NATIVE_STATS
extern int SMALL_RECT_nativeFunctionCount;
extern int SMALL_RECT_nativeFunctionCallCount[];
extern char* SMALL_RECT_nativeFunctionNames[];
#define SMALL_RECT_NATIVE_ENTER(env, that, func) SMALL_RECT_nativeFunctionCallCount[func]++;
#define SMALL_RECT_NATIVE_EXIT(env, that, func) 
#else
#ifndef SMALL_RECT_NATIVE_ENTER
#define SMALL_RECT_NATIVE_ENTER(env, that, func) 
#endif
#ifndef SMALL_RECT_NATIVE_EXIT
#define SMALL_RECT_NATIVE_EXIT(env, that, func) 
#endif
#endif

typedef enum {
	SMALL_RECT_init_FUNC,
} SMALL_RECT_FUNCS;
